;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg
; Modified for PCEnv by Andrew Miller.

;; Set up paths (todo: move out to a separate file).
!define MOZILLA "e:\users\cmiss\physiome_builds\trees\mozilla_trunk\obj-i686-pc-cygwin\stablexr\dist\bin"
!define CELLML_API "e:\users\cmiss\physiome_builds\trees\CellML_DOM_API_Win32"
!define SUPPORT_DLLS "e:\users\cmiss\physiome_builds\trees\CellML_Support_DLLs"
!define SHIPGCC "e:\users\cmiss\gcc-binary"

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "Physiome CellML Environment"
  OutFile "pcenv-installer.exe"

  ; Check for corruption of the file.
  CRCCheck on
  ; Set the compressor to use.
  SetCompressor /SOLID lzma

  ;Default installation folder
  InstallDir "$PROGRAMFILES\The University of Auckland\PCEnv"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\The University of Auckland\PCEnv" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Variables

  Var MUI_TEMP
  Var STARTMENU_FOLDER

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE  "../COPYING"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY

  ;Start Menu Folder Page Configuration
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU" 
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\The University of Auckland\PCEnv" 
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"

  !insertmacro MUI_PAGE_STARTMENU Application $STARTMENU_FOLDER
  !insertmacro MUI_PAGE_INSTFILES

  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "PCEnv" SecPCEnv

  SetOutPath "$INSTDIR" 
  File "..\COPYING"
  File ..\appSupport\win32\pcenv.exe
  File ${MOZILLA}\xulrunner.exe
  File ..\appSupport\application.ini
  SetOutPath "$INSTDIR\lib"
  File ${MOZILLA}\freebl3.dll
  File ${MOZILLA}\js3250.dll
  File ${MOZILLA}\nspr4.dll
  File ${MOZILLA}\nss3.dll
  File ${MOZILLA}\nssckbi.dll
  File ${MOZILLA}\plc4.dll
  File ${MOZILLA}\plds4.dll
  File ${MOZILLA}\smime3.dll
  File ${MOZILLA}\softokn3.dll
  File ${MOZILLA}\ssl3.dll
  File ${MOZILLA}\xpcom.dll
  File ${MOZILLA}\xul.dll
  File ..\pcenvStage\lib\omniORB407_rt.dll
  File ..\pcenvStage\lib\omnithread32_rt.dll
  File ..\pcenvStage\lib\omniDynamic407_rt.dll
  File ..\pcenvStage\lib\xpcorba.dll
  SetOutPath "$INSTDIR\components"
  File ${MOZILLA}\components\jsconsole-clhandler.js
  File ${MOZILLA}\components\nsCloseAllWindows.js
  File ${MOZILLA}\components\nsDefaultCLH.js
  File ${MOZILLA}\components\nsHelperAppDlg.js
  File ${MOZILLA}\components\nsInterfaceInfoToIDL.js
  File ${MOZILLA}\components\nsKillAll.js
  File ${MOZILLA}\components\nsProgressDialog.js
  File ${MOZILLA}\components\nsProxyAutoConfig.js
  File ${MOZILLA}\components\nsResetPref.js
  File ${MOZILLA}\components\pluginGlue.js
  File ..\pcenvStage\components\pcenv.xpt
  File ..\pcenvStage\components\xpcorba_pcenv.dll
  File ..\pcenvStage\components\xpcorba_cellml.dll
  File ..\pcenvStage\components\CellMLBootstrap.dll
  File ..\pcenvStage\components\xpcorba_mod.dll
  File ..\pcenvStage\components\DataCollector.dll
  SetOutPath "$INSTDIR\chrome"
  File ${MOZILLA}\chrome\toolkit.jar
  File ${MOZILLA}\chrome\toolkit.manifest
  File ${MOZILLA}\chrome\classic.jar
  File ${MOZILLA}\chrome\classic.manifest
  File ${MOZILLA}\chrome\en-US.jar
  File ${MOZILLA}\chrome\en-US.manifest
  File ..\appSupport\installed-chrome.txt
  File ..\chrome.manifest
  File ..\pcenvStage\chrome\pcenv.jar
  SetOutPath "$INSTDIR\res"
  File ${MOZILLA}\res\ua.css
  File ${MOZILLA}\res\quirk.css
  File ${MOZILLA}\res\hiddenWindow.html
  File ${MOZILLA}\res\forms.css
  File ${MOZILLA}\res\html.css
  SetOutPath "$INSTDIR\greprefs"
  File ${MOZILLA}\greprefs\all.js
  File ${MOZILLA}\greprefs\security-prefs.js
  SetOutPath "$INSTDIR\defaults\pref"
  File ..\appSupport\prefs.js
  SetOutPath "$INSTDIR\cellml"
  File ${CELLML_API}\.libs\ccgs_corba_bridge-0.dll
  File ${CELLML_API}\.libs\ccgs_corba_stubs-0.dll
  File ${CELLML_API}\.libs\CCGSService-0.dll
  File ${CELLML_API}\.libs\ccgs-0.dll
  File ${CELLML_API}\.libs\cellml_context_corba_bridge-0.dll
  File ${CELLML_API}\.libs\cellml_context_corba_stubs-0.dll
  File ${CELLML_API}\.libs\cellml_context-0.dll
  File ${CELLML_API}\.libs\cellml_corba_bridge-0.dll
  File ${CELLML_API}\.libs\cellml_corba_client-0.dll
  File ${CELLML_API}\.libs\cellml_corba_stubs-0.dll
  File ${CELLML_API}\.libs\cellml-0.dll
  File ${CELLML_API}\.libs\cis_corba_bridge-0.dll
  File ${CELLML_API}\.libs\cis_corba_stubs-0.dll
  File ${CELLML_API}\.libs\CISService-0.dll
  File ${CELLML_API}\.libs\cis-0.dll
  File ${CELLML_API}\.libs\CORBASupport-0.dll
  File ${CELLML_API}\.libs\cellml_corba_server.exe
  File ${SUPPORT_DLLS}\libgcc.dll
  File ${SUPPORT_DLLS}\libgsl-0.dll
  File ${SUPPORT_DLLS}\libgslcblas-0.dll
  File ${SUPPORT_DLLS}\libstdc++.dll
  File ${SUPPORT_DLLS}\libxml2-2.dll
  File ${SUPPORT_DLLS}\mingwm10.dll
  File ${SUPPORT_DLLS}\omniORB407_rt.dll
  File ${SUPPORT_DLLS}\omnithread32_rt.dll
  SetOutPath "$INSTDIR\chrome\icons\default"
  File ..\pcenvStage\chrome\icons\default\default.ico

  ;Store installation folder
  WriteRegStr HKCU "Software\The University of Auckland\PCEnv" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    
    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\$STARTMENU_FOLDER"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\PCEnv.lnk" "$INSTDIR\pcenv.exe" "" "$INSTDIR\chrome\icons\default\default.ico"
    CreateShortCut "$SMPROGRAMS\$STARTMENU_FOLDER\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  
  !insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecPCEnv ${LANG_ENGLISH} "The Physiome CellML Environment"

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecPCEnv} $(DESC_SecPCEnv)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  Delete "$INSTDIR\COPYING"
  Delete "$INSTDIR\pcenv.exe"
  Delete "$INSTDIR\xulrunner.exe"
  Delete "$INSTDIR\application.ini"
  Delete "$INSTDIR\lib\freebl3.dll"
  Delete "$INSTDIR\lib\js3250.dll"
  Delete "$INSTDIR\lib\nspr4.dll"
  Delete "$INSTDIR\lib\nss3.dll"
  Delete "$INSTDIR\lib\nssckbi.dll"
  Delete "$INSTDIR\lib\plc4.dll"
  Delete "$INSTDIR\lib\plds4.dll"
  Delete "$INSTDIR\lib\smime3.dll"
  Delete "$INSTDIR\lib\softokn3.dll"
  Delete "$INSTDIR\lib\ssl3.dll"
  Delete "$INSTDIR\lib\xpcom.dll"
  Delete "$INSTDIR\lib\xul.dll"
  Delete "$INSTDIR\lib\omniORB407_rt.dll"
  Delete "$INSTDIR\lib\omnithread32_rt.dll"
  Delete "$INSTDIR\lib\omniDynamic407_rt.dll"
  Delete "$INSTDIR\lib\xpcorba.dll"
  RMDir "$INSTDIR\lib"
  Delete "$INSTDIR\components\jsconsole-clhandler.js"
  Delete "$INSTDIR\components\nsCloseAllWindows.js"
  Delete "$INSTDIR\components\nsDefaultCLH.js"
  Delete "$INSTDIR\components\nsHelperAppDlg.js"
  Delete "$INSTDIR\components\nsInterfaceInfoToIDL.js"
  Delete "$INSTDIR\components\nsKillAll.js"
  Delete "$INSTDIR\components\nsProgressDialog.js"
  Delete "$INSTDIR\components\nsProxyAutoConfig.js"
  Delete "$INSTDIR\components\nsResetPref.js"
  Delete "$INSTDIR\components\pluginGlue.js"
  Delete "$INSTDIR\components\pcenv.xpt"
  Delete "$INSTDIR\components\xpcorba_pcenv.dll"
  Delete "$INSTDIR\components\xpcorba_cellml.dll"
  Delete "$INSTDIR\components\CellMLBootstrap.dll"
  Delete "$INSTDIR\components\xpcorba_mod.dll"
  Delete "$INSTDIR\components\DataCollector.dll"
  RMDir "$INSTDIR\components"
  Delete "$INSTDIR\chrome\toolkit.jar"
  Delete "$INSTDIR\chrome\toolkit.manifest"
  Delete "$INSTDIR\chrome\classic.jar"
  Delete "$INSTDIR\chrome\classic.manifest"
  Delete "$INSTDIR\chrome\en-US.jar"
  Delete "$INSTDIR\chrome\en-US.manifest"
  Delete "$INSTDIR\chrome\installed-chrome.txt"
  Delete "$INSTDIR\chrome\chrome.manifest"
  Delete "$INSTDIR\chrome\pcenv.jar"
  Delete "$INSTDIR\res\ua.css"
  Delete "$INSTDIR\res\quirk.css"
  Delete "$INSTDIR\res\hiddenWindow.html"
  Delete "$INSTDIR\res\forms.css"
  Delete "$INSTDIR\res\html.css"
  RMDir "$INSTDIR\res"
  Delete "$INSTDIR\greprefs\all.js"
  Delete "$INSTDIR\greprefs\security-prefs.js"
  RMDir "$INSTDIR\greprefs"
  Delete "$INSTDIR\pref\prefs.js"
  RMDir "$INSTDIR\pref"
  Delete "$INSTDIR\cellml\ccgs_corba_bridge-0.dll"
  Delete "$INSTDIR\cellml\ccgs_corba_stubs-0.dll"
  Delete "$INSTDIR\cellml\CCGSService-0.dll"
  Delete "$INSTDIR\cellml\ccgs-0.dll"
  Delete "$INSTDIR\cellml\cellml_context_corba_bridge-0.dll"
  Delete "$INSTDIR\cellml\cellml_context_corba_stubs-0.dll"
  Delete "$INSTDIR\cellml\cellml_context-0.dll"
  Delete "$INSTDIR\cellml\cellml_corba_bridge-0.dll"
  Delete "$INSTDIR\cellml\cellml_corba_client-0.dll"
  Delete "$INSTDIR\cellml\cellml_corba_stubs-0.dll"
  Delete "$INSTDIR\cellml\cellml-0.dll"
  Delete "$INSTDIR\cellml\cis_corba_bridge-0.dll"
  Delete "$INSTDIR\cellml\cis_corba_stubs-0.dll"
  Delete "$INSTDIR\cellml\CISService-0.dll"
  Delete "$INSTDIR\cellml\cis-0.dll"
  Delete "$INSTDIR\cellml\CORBASupport-0.dll"
  Delete "$INSTDIR\cellml\cellml_corba_server.exe"
  Delete "$INSTDIR\cellml\libgcc.dll"
  Delete "$INSTDIR\cellml\libgsl-0.dll"
  Delete "$INSTDIR\cellml\libgslcblas-0.dll"
  Delete "$INSTDIR\cellml\libstdc++.dll"
  Delete "$INSTDIR\cellml\libxml2-2.dll"
  Delete "$INSTDIR\cellml\mingwm10.dll"
  Delete "$INSTDIR\cellml\omniORB407_rt.dll"
  Delete "$INSTDIR\cellml\omnithread32_rt.dll"
  RMDir "$INSTDIR\cellml"
  Delete "$INSTDIR\chrome\icons\default\default.ico"
  RMDir "$INSTDIR\chrome\icons\default"
  RMDir "$INSTDIR\chrome\icons"
  RMDir "$INSTDIR\chrome"
  Delete "$INSTDIR\Uninstall.exe"

  RMDir "$INSTDIR"

  !insertmacro MUI_STARTMENU_GETFOLDER Application $MUI_TEMP

  Delete "$SMPROGRAMS\$MUI_TEMP\Uninstall.lnk"

  ;Delete empty start menu parent diretories
  StrCpy $MUI_TEMP "$SMPROGRAMS\$MUI_TEMP"

  startMenuDeleteLoop:
	ClearErrors
    RMDir $MUI_TEMP
    GetFullPathName $MUI_TEMP "$MUI_TEMP\.."
    
    IfErrors startMenuDeleteLoopDone
  
    StrCmp $MUI_TEMP $SMPROGRAMS startMenuDeleteLoopDone startMenuDeleteLoop
  startMenuDeleteLoopDone:

  DeleteRegKey /ifempty HKCU "Software\The University of Auckland\PCEnv"

SectionEnd
